﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GotLyrics.Dialogs
{
    public partial class BaseDialog : Form
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BaseDialog"/> class.
        /// </summary>
        /// <remarks>
        /// Design time only constructor.
        /// </remarks>
        private BaseDialog()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BaseDialog"/> class.
        /// </summary>
        /// <param name="mainForm">The main form.</param>
        public BaseDialog(GotLyricsMainForm mainForm)
        {
            _mainForm = mainForm;
            InitializeComponent();
        }

        private GotLyricsMainForm _mainForm;
        /// <summary>
        /// Gets or sets the main form.
        /// </summary>
        /// <value>The main form.</value>
        protected GotLyricsMainForm MainForm
        {
            get { return this._mainForm; }
        }			
    }
}
