﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GotLyrics.Dialogs
{
    public partial class FilenameOptionsDialog : GotLyrics.Dialogs.BaseDialog
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RenameFilesOptionsDialog"/> class.
        /// </summary>
        public FilenameOptionsDialog(GotLyricsMainForm mainForm) : base(mainForm)
        {
            InitializeComponent();
        }

        /// <summary>
        /// Gets or sets a value indicating whether to replace spaces with underscores.
        /// </summary>
        /// <value><c>true</c> if replacing spaces; otherwise, <c>false</c>.</value>
        public bool ReplaceSpaces
        {
            get { return chkReplaceSpaces.Checked; }
            set { chkReplaceSpaces.Checked = value; }
        }

        /// <summary>
        /// Gets or sets the word casing.
        /// </summary>
        /// <value>The word casing.</value>
        public WordCasingType WordCasing
        {
            get { return wordCasingOptions.CasingType; }
            set { wordCasingOptions.CasingType = value; }
        }

        /// <summary>
        /// Gets or sets the check box text.
        /// </summary>
        /// <value>The check box text.</value>
        public string CheckBoxText
        {
            get { return chkReplaceSpaces.Text; }
            set { chkReplaceSpaces.Text = value; }
        }
    }
}
