﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GotLyrics
{
    public class AudioFileSelectionChangeEventArgs : EventArgs
    {
        private AudioFileContext[] _selection = null;
        /// <summary>
        /// Gets the selection.
        /// </summary>
        /// <value>The selection.</value>
        public AudioFileContext[] Selection
        {
            get{return _selection;}
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="FileSelectionChangeEventArgs"/> class.
        /// </summary>
        /// <param name="selection">The selection.</param>
        public AudioFileSelectionChangeEventArgs(AudioFileContext[] selection)
            : base()
        {
            _selection = selection;
        }
    }
}
