﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace GotLyrics
{
    /// <summary>
    /// The log class.
    /// </summary>
    public static class Log
    {
        private static TextBox _textBox = new TextBox();
        /// <summary>
        /// Gets or sets the text box.
        /// </summary>
        /// <value>The text box.</value>
        public static TextBox TextBox
        {
            get { return _textBox; }
            set { _textBox = value; }
        }

        private static LogLevel _logLevel;
        /// <summary>
        /// Gets or sets the log level.
        /// </summary>
        /// <value>The log level.</value>
        public static LogLevel LogLevel
        {
            get { return _logLevel; }
            set { _logLevel = value; }
        }
        

    }

    /// <summary>
    /// The log level used by the <see cref="Log"/> class
    /// </summary>
    public enum LogLevel
    {
        /// <summary>
        /// Debug level
        /// </summary>
        Debug = 0,
        /// <summary>
        /// Info level
        /// </summary>
        Info = 1,
        /// <summary>
        /// Error level
        /// </summary>
        Error = 2
    }
}
