﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GotLyrics
{
    public class ExecutingGrabberEventArgs : EventArgs
    {
        internal ExecutingGrabberEventArgs(LyricGrabberContext context, ILyricGrabber lyricGrabber)
        {
            _context = context;
            _lyricGrabber = lyricGrabber;
        }

        private LyricGrabberContext _context;
        /// <summary>
        /// Gets the context.
        /// </summary>
        /// <value>The context.</value>
        public LyricGrabberContext Context
        {
            get { return _context; }
        }

        private ILyricGrabber _lyricGrabber;
        /// <summary>
        /// Gets the lyric grabber.
        /// </summary>
        /// <value>The lyric grabber.</value>
        public ILyricGrabber LyricGrabber
        {
            get { return _lyricGrabber; }
        }
    }
}
