﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GotLyrics
{
    public class GrabberErrorEventArgs : EventArgs
    {
        internal GrabberErrorEventArgs(LyricGrabberContext context, ILyricGrabber grabber, Exception ex)
        {
            _exception = ex;
            _lyricGrabber = grabber;
            _context = context;
        }

        private bool _continue;
        /// <summary>
        /// Set this to true if you want to continue the process.
        /// </summary>
        /// <value><c>true</c> if continue; otherwise, <c>false</c>.</value>
        public bool Continue
        {
            get { return _continue; }
            set { _continue = value; }
        }

        private Exception _exception;
        /// <summary>
        /// Gets the exception.
        /// </summary>
        /// <value>The exception.</value>
        public Exception Exception
        {
            get { return _exception; }
        }

        private LyricGrabberContext _context;
        /// <summary>
        /// Gets the context.
        /// </summary>
        /// <value>The context.</value>
        public LyricGrabberContext Context
        {
            get { return _context; }
        }

        private ILyricGrabber _lyricGrabber;
        /// <summary>
        /// Gets the lyric grabber.
        /// </summary>
        /// <value>The lyric grabber.</value>
        public ILyricGrabber LyricGrabber
        {
            get { return _lyricGrabber; }
        }
    }
}
