﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GotLyrics
{
    public class LyricsFoundEventArgs : EventArgs
    {
        internal LyricsFoundEventArgs(LyricGrabberContext context, ILyricGrabber grabber, string lyrics)
        {
            _context = context;
            _lyricGrabber = grabber;
            _lyrics = lyrics;
        }

        private LyricGrabberContext _context;
        /// <summary>
        /// Gets the context.
        /// </summary>
        /// <value>The context.</value>
        public LyricGrabberContext Context
        {
            get { return _context; }
        }

        private ILyricGrabber _lyricGrabber;
        /// <summary>
        /// Gets the lyric grabber.
        /// </summary>
        /// <value>The lyric grabber.</value>
        public ILyricGrabber LyricGrabber
        {
            get { return _lyricGrabber; }
        }

        private string _lyrics;
        /// <summary>
        /// Gets the lyrics.
        /// </summary>
        /// <value>The lyrics.</value>
        public string Lyrics
        {
            get { return _lyrics; }
        }

        private bool _continue;
        /// <summary>
        /// Set this to true to continue the search on the next grabber.
        /// </summary>
        /// <value><c>true</c> to continue; otherwise, <c>false</c>.</value>
        public bool Continue
        {
            get { return _continue; }
            set { _continue = value; }
        }
    }
}
