﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GotLyrics
{
    public class ProcessFileErrorEventArgs : EventArgs
    {
        internal ProcessFileErrorEventArgs(string filename, Exception ex)
        {
            _filename = filename;
            _exception = ex;
        }

        private bool _continue;
        /// <summary>
        /// Gets or sets a value indicating whether to continue processing files.
        /// </summary>
        /// <value><c>true</c> to continue; otherwise, <c>false</c>.</value>
        public bool Continue
        {
            get { return _continue; }
            set { _continue = value; }
        }

        private Exception _exception;
        /// <summary>
        /// Gets the exception that has occured.
        /// </summary>
        /// <value>The exception.</value>
        public Exception Exception
        {
            get { return _exception; }
        }

        private string _filename;

        /// <summary>
        /// Gets the filename.
        /// </summary>
        /// <value>The filename.</value>
        public string Filename
        {
            get { return _filename; }
        }
    }
}
