﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GotLyrics
{
    /// <summary>
    /// 
    /// </summary>
    public class ProcessFileEventArgs : EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProcessFileEventArgs"/> class.
        /// </summary>
        /// <param name="filename">The filename.</param>
        internal ProcessFileEventArgs(LyricGrabberContext context)
        {
            _context = context;
        }

        private LyricGrabberContext _context;
        /// <summary>
        /// Gets the context.
        /// </summary>
        /// <value>The context.</value>
        public LyricGrabberContext Context
        {
            get { return _context; }
        }

        private bool _skipFile;
        /// <summary>
        /// Gets or sets a value indicating whether to skip this file.
        /// </summary>
        /// <value><c>true</c> to skip this file; otherwise, <c>false</c>.</value>
        public bool SkipFile
        {
            get { return _skipFile; }
            set { _skipFile = value; }
        }
    }
}
