﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GotLyrics
{
    /// <summary>
    /// This is the interface for both the <see cref="LyricScrapeGrabber"/> and the <see cref="LyricWebServiceGrabber"/>.
    /// </summary>
    public interface ILyricGrabber
    {
        /// <summary>
        /// Gets the name.
        /// </summary>
        /// <value>The name.</value>
        string Name { get; }

        /// <summary>
        /// Gets or sets a value indicating whether this <see cref="ILyricGrabber"/> is enabled.
        /// </summary>
        /// <value><c>true</c> if enabled; otherwise, <c>false</c>.</value>
        bool Enabled { get; set; }

        /// <summary>
        /// The website of this lyrics provider
        /// </summary>
        string WebSiteUrl { get; }

        /// <summary>
        /// Processes the request.
        /// </summary>
        /// <param name="context">The context.</param>
        /// <returns></returns>
        string Execute(LyricGrabberContext context);
    }
}
